Subject: Re: [PATCH] spidernet: fix interrupt reason recognition

From: [email-masked] (Linas Vepstas)
Date: Tue, 4 Sep 2007 18:49:54 -0500

On Fri, Aug 31, 2007 at 06:46:17AM -0400, Jeff Garzik wrote:
> Ishizaki Kou wrote:
> >This patch solves a problem that the spidernet driver sometimes fails
> >to handle IRQ.
> >
> >The problem happens because,
> >- In Cell architecture, interrupts may arrive at an interrupt
> >  controller, even if they are masked by the setting on registers of
> >  devices. It happens when interrupt packets are sent just before 
> >  the interrupts are masked.
> >- spidernet interrupt handler compares interrupt reasons with
> >  interrupt masks, so when such interrupts occurs, spidernet interrupt
> >  handler returns IRQ_NONE.
> >- When all of interrupt handler return IRQ_NONE, linux kernel disables
> >  the IRQ and it no longer delivers interrupts to the interrupt handlers.
> >
> >spidernet doesn't work after above sequence, because it can't receive
> >interrupts.
> > 
> >This patch changes spidernet interrupt handler that it compares
> >interrupt reason with SPIDER_NET_INTX_MASK_VALUE.
> >
> >Signed-off-by: Kou Ishizaki <[email-masked]>
> >---
> >
> >Linas-san,
> >
> >Please apply this to 2.6.23. Because this problem is sometimes happens
> >and we cannot use the ethernet port any more.
> >
> >And also, please apply the following Arnd-san's patch to fix a problem
> >that spidernet driver sometimes causes a BUG_ON at open.
> 
> Linas?  ACK?  Alive?  :)

Argh. I read the code; it looked fine. I was going to compile it and
forward it formally and etc. and then I got busy ...

Ack'ed by: Linas Vepstas <[email-masked]>

--linas